



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Swift学习（一）：自定义运算符 operator</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Swift学习（一）：自定义运算符 operator</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 09:21:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>自定义运算符仅能包含这些字符：</p>
<div>
<pre class="prettyprint linenums">/ = - + * % &lt; &gt;！&amp; | ^。~</pre>
</div>
<p>运算符位置：</p>
<div>
<pre class="prettyprint linenums">前置运算符    prefix<br />
中间运算符    infix<br />
后置运算符    postfix</pre>
</div>
<p>运算符其他配置</p>
<div>
<pre class="prettyprint linenums">结合性        associativity<br />
可取值范围    left，right和none

优先级        precedence<br />
可取值范围    ～

系统内置运算符结合性质及优先级<br />
    求幂相关（无结合，优先级160）<br />
        &lt;&lt; 按位左移（Bitwise left shift）<br />
        &gt;&gt; 按位右移（Bitwise right shift）

    乘除法相关（左结合，优先级150）<br />
        * 乘<br />
        / 除<br />
        % 求余<br />
        &amp;* 乘法，忽略溢出（ Multiply, ignoring overflow）<br />
        &amp;/ 除法，忽略溢出（Divide, ignoring overflow）<br />
        &amp;% 求余, 忽略溢出（ Remainder, ignoring overflow）<br />
        &amp; 位与（ Bitwise AND）

    加减法相关（左结合, 优先级140）<br />
        + 加<br />
        - 减<br />
        &amp;+ Add with overflow<br />
        &amp;- Subtract with overflow<br />
        | 按位或（Bitwise OR ）<br />
        ^ 按位异或（Bitwise XOR）

    Range （无结合,优先级 ）<br />
        .. 半闭值域 Half-closed range<br />
        ... 全闭值域 Closed range

    类型转换 （无结合,优先级 ）<br />
        is 类型检查（ type check）<br />
        as 类型转换（ type cast）<br />
        &lt;= 小于等于<br />
        &gt;大于<br />
        &gt;= 大于等于<br />
        == 等于<br />
        != 不等<br />
        === 恒等于<br />
        !== 不恒等<br />
        ~= 模式匹配（ Pattern match）

    合取（ Conjunctive） （左结合,优先级 ）<br />
        &amp;&amp; 逻辑与（Logical AND）

    析取（Disjunctive） （左结合,优先级 ）<br />
        || 逻辑或（ Logical OR）

    三元条件（Ternary Conditional ）（右结合,优先级 ）<br />
        ?: 三元条件 Ternary conditional

    赋值 （Assignment） （右结合, 优先级 ）<br />
        = 赋值（Assign）<br />
        *= Multiply and assign<br />
        /= Divide and assign<br />
        %= Remainder and assign<br />
        += Add and assign<br />
        -= Subtract and assign<br />
        &lt;&lt;= Left bit shift and assign<br />
        = Right bit shift and assign<br />
        &amp;= Bitwise AND and assign<br />
        ^= Bitwise XOR and assign<br />
        |= Bitwise OR and assign<br />
        &amp;&amp;= Logical AND and assign<br />
        ||= Logical OR and assign</pre>
</div>
<p>范例</p>
<div>
<pre class="prettyprint linenums">// 前置：返回2的n次方<br />
prefix operator  ^ {}

prefix func ^ (var vector: Double) -&gt; Double {<br />
    return pow(, vector)<br />
}

println(^)  // 32.0

// 后置：返回2次方<br />
postfix operator  ^ {}

postfix func ^ (var vector: Int) -&gt; Int {<br />
    return vector * vector<br />
}

println(^)  // 25

//中间：计算N的M次方，左结合，优先级为255<br />
infix operator ^^ {associativity left precedence }

func ^^(left: Double, right: Double) -&gt; Double {<br />
    return pow(left, right)<br />
}

println( ^^  -  ^^ )  // 1024 － 8 ＝ 1016</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jepw85.html">Create a Team in RHEL7</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o1ov5q.html">Netbeans配置Xdebug</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gpdwl9.html">Windows on Device 项目实践 3 - 火焰报警器制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mk3jrq.html">JavaWeb 学习001-登录页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8myeyr8.html">java面试中问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdrjlx8.html">MySQL性能优化的最佳21条经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xrl28.html">论meta name&equals; viewport content&equals; width&equals;device-width initial-scale&equals;1 minimum-scale&equals;1 maximum-scale&equals;1的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903gm49.html">step byt step之餐饮管理系统一</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvlony8.html">&lbrack;原&rsqb;OpenGL基础教程（二）多边形绘制</a>
		</li>
						<li><a href="https://www.batexi.com/a/39romm79.html">an error occurred during the file system check错误的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11rdz9.html">jquery  全选功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11v4z9.html">Go语言并发与并行学习笔记&lpar;三&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4yjmq.html">基于jQuery的AJAX和JSON的实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zl3j49.html">C&num; 计时器的三种使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ke24q.html">JavaScript学习笔记&mdash;&mdash;简单无缝循环滚动展示图片的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jze3g48.html">linux shell&colon; 取得某个目录下的文件名列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2j648.html">Spark SQL数据加载和保存实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zg6je9.html">scrapy配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jv06v8.html">非阻塞式的原子性操作-CAS应用及原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7wx08.html">ABP框架连接Mysql数据库</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93px3z8.html">使用CruiseControl&period;Net全面实现持续集成</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwlj1k9.html">css3中动画&lpar;transition&rpar;和过渡&lpar;animation&rpar;详析</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gpj7l9.html">Linux安全基础：网络配置命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/m963mj49.html">Handler&period;sendMessage 与 Handler&period;obtainMessage&period;sendToTarget比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93pjyn8.html">Thread多线程（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gp4e49.html">android 四大组件之---Service</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rn74mq.html">&period;NET应用架构设计&mdash;用户端的防腐层作用及设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7edkk9.html">使用js 设置组合快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8emwdm9.html">终于开始用github了</a>
			</li>
						<li><a href="https://www.batexi.com/a/m963l049.html">Asp&period;Net MVC&plus;BootStrap&plus;EF6&period;0实现简单的用户角色权限管理7</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
